.386
.model flat,stdcall
option casemap:none

include	    \masm32\include\windows.inc
include		\masm32\include\user32.inc
include		\masm32\include\kernel32.inc
include 	\masm32\include\gdi32.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\gdi32.lib

.const


.data
classname		db "Glass Window Hole [MASM]",0


.data?
hinst				HINSTANCE ?
hr					HRGN ?
hr0					HRGN ?

.code

; ************************************

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

local rc:RECT

	mov eax,uMsg
	
	.if eax==WM_DESTROY
		invoke DeleteObject,hr
		invoke DeleteObject,hr0
		invoke PostQuitMessage,0

	.elseif eax==WM_CREATE		

		invoke CreateRectRgn,10,30,80,80
		mov hr0,eax
		
		invoke GetWindowRect,hWnd,addr rc
		mov eax,rc.right
		mov ecx,rc.bottom
		sub eax,rc.left
		sub ecx,rc.top
		invoke CreateRectRgn,0,0,eax,ecx
		mov hr,eax
		invoke CombineRgn,hr,hr,hr0,RGN_DIFF	
		invoke SetWindowRgn,hWnd,hr,1

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

; ************************************

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,lpszArgs:LPSTR,CmdShow:DWORD
	local wc:WNDCLASSEX
	local msg:MSG
	local hw:HWND

	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,0
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov eax,hInst
	mov wc.hInstance,eax
	mov wc.hbrBackground,COLOR_BTNFACE+1 ;COLOR_WINDOW+1
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset classname
	invoke LoadIcon,0,IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm,eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,WS_EX_TOPMOST,offset classname,offset classname,WS_POPUP or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX,250,250,280,250,0,0,hInst,0
	mov hw,eax


	invoke ShowWindow,hw,CmdShow
	invoke UpdateWindow,hw
	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

; ************************************

start:
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke WinMain,eax,0,0,SW_SHOWDEFAULT
	invoke ExitProcess,eax
end start
; ************************************
