.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

WinMain				PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc				PROTO :DWORD,:DWORD,:DWORD,:DWORD

.const

IDI_ICON      equ 200


.data

ClassName			db 'DLGCLASS',0
DlgName				db 'MyDialog',0
AppName				db 'Glass Window Hole [MASM]',0

.data?

hInstance			dd ?
CommandLine			dd ?
hWnd				dd ?
hDlg				dd ?
hIcon     HICON     ?
hr					HRGN ?
hr0					HRGN ?
.code

start:

	INVOKE GetModuleHandle,NULL
	mov    hInstance,eax
    INVOKE LoadIcon, eax, IDI_ICON 
    mov hIcon, eax  
	INVOKE GetCommandLine
	INVOKE InitCommonControls
	INVOKE WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	INVOKE ExitProcess,eax
; ************************************
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszClassName,OFFSET ClassName
	INVOKE LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	INVOKE LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	INVOKE RegisterClassEx,addr wc
	INVOKE CreateDialogParam,hInstance,addr DlgName,NULL,addr WndProc,NULL
	INVOKE ShowWindow,hWnd,SW_SHOWNORMAL
	INVOKE UpdateWindow,hWnd
	

	.WHILE TRUE
		INVOKE GetMessage,addr msg,NULL,0,0
	  .BREAK .IF !eax
		INVOKE IsDialogMessage, hDlg, ADDR msg
		.IF !eax
			INVOKE TranslateMessage, ADDR msg
			INVOKE DispatchMessage, ADDR msg
		.ENDIF
	.ENDW
	mov		eax,msg.wParam
	ret

WinMain endp
; ************************************
WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

local rc:RECT
	mov		eax,uMsg
	.IF eax==WM_CREATE
	push		hWin
	pop		hWnd
	INVOKE SetWindowText, hWnd, addr AppName	
	INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
		INVOKE CreateRectRgn,10,30,80,80
		mov hr0,eax
		
		INVOKE GetWindowRect,hWnd,addr rc
		mov eax,rc.right
		mov ecx,rc.bottom
		sub eax,rc.left
		sub ecx,rc.top
		INVOKE CreateRectRgn,0,0,eax,ecx
		mov hr,eax
		INVOKE CombineRgn,hr,hr,hr0,RGN_DIFF	
		INVOKE SetWindowRgn,hWnd,hr,1
	.ELSEIF eax==WM_COMMAND
	mov		eax,wParam
	and		eax,0FFFFh


	.ELSEIF eax==WM_DESTROY
	INVOKE DeleteObject,hr
	INVOKE DeleteObject,hr0
	INVOKE PostQuitMessage,NULL
	.ELSE
	INVOKE DefWindowProc,hWin,uMsg,wParam,lParam
    ret
	.ENDIF
	xor eax,eax
	ret

WndProc endp
; ************************************
end start
