.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\gdi32.inc 
include  \masm32\include\shell32.inc


includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\gdi32.lib 
includelib  \masm32\lib\shell32.lib
include 	\masm32\include\msimg32.inc
includelib 	\masm32\lib\msimg32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	   equ 101
IDI_ICON       equ 200

; Required data

.data



.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hr		  HRGN ?
hr0		  HRGN ?
.code

start:



INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, SW_SHOWDEFAULT
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

local rc:RECT

Mov		Eax, uMsg
	.If  Eax == WM_INITDIALOG
		invoke CreateRectRgn,10,10,80,80
		mov hr0,eax
		
		invoke GetWindowRect,hWnd,addr rc
		mov eax,rc.right
		mov ecx,rc.bottom
		sub eax,rc.left
		sub ecx,rc.top
		invoke CreateRectRgn,0,0,eax,ecx
		mov hr,eax
		invoke CombineRgn,hr,hr,hr0,RGN_DIFF	
		invoke SetWindowRgn,hWnd,hr,1
 
.ElseIf eax == WM_LBUTTONDOWN
	invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0
	;The WM_NCLBUTTONDOWN message is posted when the user presses the left mouse button while the cursor is within the 
	;nonclient area of a window. This message is posted to the window that contains the cursor. If a window has captured the 
	;mouse, this message is not posted. 
    .ELSEIF  uMsg == WM_COMMAND
    .ELSEIF  uMsg == WM_CLOSE || uMsg == WM_RBUTTONUP
    INVOKE DeleteObject,hr
	INVOKE DeleteObject,hr0
    INVOKE EndDialog, hWnd, 0
    .ENDIF
 
  xor eax,eax
  ret
DialogProc endp

end start